// Objective-C API for talking to blink.com/quicproxy/bailingquic Go package.
//   gobind -lang=objc blink.com/quicproxy/bailingquic
//
// File is generated by gobind. Do not edit.

#ifndef __Bailingquic_H__
#define __Bailingquic_H__

@import Foundation;
#include "Universe.objc.h"


@class BailingquicHttpClient;
@class BailingquicHttpQuicCallback;
@class BailingquicQuicConn;
@protocol BailingquicIConn;
@class BailingquicIConn;
@protocol BailingquicIConnCallback;
@class BailingquicIConnCallback;
@protocol BailingquicIConnIncomingCallback;
@class BailingquicIConnIncomingCallback;
@protocol BailingquicIHttpCallback;
@class BailingquicIHttpCallback;
@protocol BailingquicIHttpClient;
@class BailingquicIHttpClient;

@protocol BailingquicIConn <NSObject>
- (BOOL)connect:(NSString*)add error:(NSError**)error;
- (BOOL)disconnect:(NSError**)error;
- (NSString*)getId;
- (void)registerCallback:(id<BailingquicIConnCallback>)callback;
- (void)setId:(NSString*)s;
- (NSString*)string;
- (BOOL)write:(NSData*)b n:(long*)n error:(NSError**)error;
@end

@protocol BailingquicIConnCallback <NSObject>
- (void)onConnected:(id<BailingquicIConn>)conn;
- (void)onDataReceived:(id<BailingquicIConn>)conn data:(NSData*)data;
- (void)onDisconnected:(id<BailingquicIConn>)conn;
@end

@protocol BailingquicIConnIncomingCallback <NSObject>
- (void)onIncomingConnectionConnected:(id<BailingquicIConn>)conn;
@end

@protocol BailingquicIHttpCallback <NSObject>
- (void)onResponseReceived:(NSData*)data err:(NSError*)err;
@end

@protocol BailingquicIHttpClient <NSObject>
- (BOOL)get:(NSString*)httpUrl callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
- (BOOL)post:(NSString*)httpUrl form:(NSString*)form callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
@end

@interface BailingquicHttpClient : NSObject <goSeqRefInterface, BailingquicIHttpClient> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (id<BailingquicIHttpClient>)iHttpClient;
- (void)setIHttpClient:(id<BailingquicIHttpClient>)v;
- (BOOL)disconnect:(NSError**)error;
- (BOOL)get:(NSString*)httpUrl callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
- (BOOL)post:(NSString*)httpUrl form:(NSString*)form callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
@end

@interface BailingquicHttpQuicCallback : NSObject <goSeqRefInterface, BailingquicIConnCallback> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (id<BailingquicIConnCallback>)iConnCallback;
- (void)setIConnCallback:(id<BailingquicIConnCallback>)v;
- (void)onConnected:(id<BailingquicIConn>)conn;
- (void)onDataReceived:(id<BailingquicIConn>)conn data:(NSData*)data;
- (void)onDisconnected:(id<BailingquicIConn>)conn;
@end

@interface BailingquicQuicConn : NSObject <goSeqRefInterface, BailingquicIConn> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (instancetype)init;
- (id<BailingquicIConn>)iConn;
- (void)setIConn:(id<BailingquicIConn>)v;
- (BOOL)connect:(NSString*)add error:(NSError**)error;
- (BOOL)disconnect:(NSError**)error;
- (NSString*)getId;
- (void)registerCallback:(id<BailingquicIConnCallback>)callback;
- (void)setId:(NSString*)s;
- (NSString*)string;
- (BOOL)write:(NSData*)b n:(long*)n error:(NSError**)error;
@end

FOUNDATION_EXPORT BailingquicQuicConn* BailingquicNewQuicConn(void);

@class BailingquicIConn;

@class BailingquicIConnCallback;

@class BailingquicIConnIncomingCallback;

@class BailingquicIHttpCallback;

@class BailingquicIHttpClient;

@interface BailingquicIConn : NSObject <goSeqRefInterface, BailingquicIConn> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (BOOL)connect:(NSString*)add error:(NSError**)error;
- (BOOL)disconnect:(NSError**)error;
- (NSString*)getId;
- (void)registerCallback:(id<BailingquicIConnCallback>)callback;
- (void)setId:(NSString*)s;
- (NSString*)string;
- (BOOL)write:(NSData*)b n:(long*)n error:(NSError**)error;
@end

@interface BailingquicIConnCallback : NSObject <goSeqRefInterface, BailingquicIConnCallback> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)onConnected:(id<BailingquicIConn>)conn;
- (void)onDataReceived:(id<BailingquicIConn>)conn data:(NSData*)data;
- (void)onDisconnected:(id<BailingquicIConn>)conn;
@end

@interface BailingquicIConnIncomingCallback : NSObject <goSeqRefInterface, BailingquicIConnIncomingCallback> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)onIncomingConnectionConnected:(id<BailingquicIConn>)conn;
@end

@interface BailingquicIHttpCallback : NSObject <goSeqRefInterface, BailingquicIHttpCallback> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (void)onResponseReceived:(NSData*)data err:(NSError*)err;
@end

@interface BailingquicIHttpClient : NSObject <goSeqRefInterface, BailingquicIHttpClient> {
}
@property(strong, readonly) id _ref;

- (instancetype)initWithRef:(id)ref;
- (BOOL)get:(NSString*)httpUrl callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
- (BOOL)post:(NSString*)httpUrl form:(NSString*)form callback:(id<BailingquicIHttpCallback>)callback error:(NSError**)error;
@end

#endif
